export interface FightParam {
    type:               string, // 功能类型
    ownAttr:            any, // 攻方属性
    enemyAttr:          any, // 守方属性
    endCallback:        Function, // 战斗结束回调
    killCallback?:        Function, // 战斗被强制结束后的回调
    isFastSkip?:         boolean, // 是否快速跳过， 即不演播战斗过程
    needVerify?:        boolean, // 前端用，主要是用于前端验证，即发起战斗时会有一场不演播的战斗，完成后再进行战斗演播，战斗的结果为不演播战斗的结果
    fightVersion?:      number, // 战斗版本号，版本号如果传了且不一致的不播放战斗回放
    fightBg?:             string, // 非必传：战斗场景，如果是快速跳过战斗则可不传
    seed?:              number, // 非必传，战斗用随机种子ID
    attackHeadInfo?:    any, // 攻方的头像信息
    defendHeadInfo?:    any, // 守方的头像信息
    closeCallback?:     Function, // 非必传：战斗页面关闭时的回调
    skipText?:          string, // 暂停UI中，的跳过文字类型，没有传则显示逃跑
    speed?:             number | undefined; // 默认速度值
    fightStartNeedChangeAttr?: { own: any, enemy: any, owntype: 0 | 1, enemytype: 0 | 1 } | null;
    openNextFightFun?:   Function, // 连续战斗时调用下一场战斗需要用到的判断和数据获取方法
    fight_cd_time?: number; // 自动连续战斗时的cd
    bossId?:number; // 兽海bossid
    monsterSeaHurtCfg?: string; // 兽海配置表路径
    shengqiInfo?: {own?: {hallowsId: number, level: number, star: number}, enemy?: {hallowsId: number, level: number, star: number}} | Map<number, {own?: {hallowsId: number, level: number, star: number}, enemy?: {hallowsId: number, level: number, star: number}}>,
    ridInfo?: {own: number, enemy: number}, // 己方和敌方的rid
    fKey?: number, // 功能编队key
    teamNo?: number // 出站队伍编号
    tr?,
}