/**
 * 战斗
 */
// --------------------------导入-------------------------
import { FightParam } from 'game_fight_entry/base/interface';
import { dontShowPidFightEntry, getFightDeadNum, getFightHpData } from 'game_fight_entry/base/entry';

// 注册pid rpc 方法
//#[event=process_send_msg, src=pid_rpc]
export const processSendMsg =  (_eventName: string, arg) => {
    let seed = arg.seed, fight = 0, result, hpInfo, deadList;
    let backFightInfo: FightParam = {
        ownAttr: JSON.parse(arg.attackAttr), // 己方属性
        enemyAttr: JSON.parse(arg.defendAttr), // 敌方数据
        seed, // 随机种子
        type: arg.from, // 战斗类型
        fightStartNeedChangeAttr: arg.fightStartNeedChangeAttr ? JSON.parse(arg.fightStartNeedChangeAttr) : null,
        ridInfo: { own: arg.rid, enemy: arg.otherRid },
        fKey: arg.fKey,
        teamNo: arg.teamNo,
        shengqiInfo: arg.shengqiInfo,
        endCallback: (r, _, _msg) => {
            fight = r;
            result = _msg;
            hpInfo = getFightHpData();
            deadList = getFightDeadNum();
        }
    };
    if (JSON.parse(arg.attackAttr).length == 0 || JSON.parse(arg.defendAttr).length == 0) {
        return {
            key: arg.key,
            r: 4,
            mqttNotifyName: arg.mqttNotifyName,
        }
    }
    try {
        // 后端战斗，没有演播过程，直接出结果
        dontShowPidFightEntry(backFightInfo);
    } catch (e) {
        console.log(e.stack);
        return {
            key: arg.key,
            r: 4,
            mqttNotifyName: arg.mqttNotifyName,
        }
    }
    
    return {
        key: arg.key,
        r: fight,
        recount: result?.recount,
        play_list: result?.play_list,
        monster_list: result?.monster_list,
        fList: result?.fList,
        mList: result?.mList,
        count: result?.count,
        seed: result?.seed,
        fightVersion: result?.fightVersion,
        shengqiInfo: result?.shengqiInfo,
        hpInfo,
        deadList,
        mqttNotifyName: arg.mqttNotifyName,
        // ownAttr: attr[0].ownAttr,
        // enemyAttr: attr[0].enemyAttr,
    };
}
