import { globalSend } from "game_root/client/event";
import { FightParam } from "../base/interface";
import { checkDefendIsMonster } from "../base/utils";
import { clearFightData } from "game_fight_entry/base/entry";

export const showFightEntry = (param: FightParam) => {
    let fightType = checkDefendIsMonster(param.enemyAttr);
    let shengqiInfo = param.shengqiInfo instanceof Map ? param.shengqiInfo.get(1) : param.shengqiInfo;
    globalSend("gotoFight", {
        type: param.type,
        ownAttr: param.ownAttr,
        enemyAttr: param.enemyAttr,
        endCallback: param.endCallback,
        isFastSkip: param.isFastSkip,
        needVerify: param.needVerify,
        fightVersion: param.fightVersion,
        scene: param.fightBg,
        seed: param.seed,
        attackHeadInfo: param.attackHeadInfo,
        defendHeadInfo: param.defendHeadInfo,
        closeCallback: param.closeCallback,
        fightType: fightType,
        isFury: fightType == "pve" ? false : true,
        skipText: param.skipText,
        backFightStopTime: 3000000,
        speed: param.speed,
        fightStartNeedChangeAttr: param.fightStartNeedChangeAttr,
        notCleanData: false,
        bossId: param.bossId,
        monsterSeaHurtCfg: param.monsterSeaHurtCfg,
        shengqiInfo
    })
}

export const moreTeamsShowFightEntry = (param: FightParam) => {
    let fightResult: any[] = [];// 记录战斗结果，在战斗结束后进行展示
    let roundInfo: any[] = [];
    if (!param.enemyAttr || !param.ownAttr) {
        return;
    }

    if (param.enemyAttr.size == 0 || param.ownAttr.size == 0){
        return;
    }
    let shengqiInfo = param.shengqiInfo instanceof Map ? param.shengqiInfo : (new Map()).set(1, param.shengqiInfo)
    // 如果传了fight_cd_time。需要判断战力限制是否通过

    // 通讯完成后在播放战斗
    const fun = (index) => {        
        let ownAttr = param.ownAttr.get(index);
        let enemyAttr = param.enemyAttr.get(index);
        let seed = param.seed?.get(index);
        let fightType = checkDefendIsMonster(enemyAttr);
        let fightData: any = {
            type: param.type,
            ownAttr,
            enemyAttr,
            isFastSkip: param.isFastSkip,
            needVerify: param.needVerify,
            fightVersion: param.fightVersion,
            scene: param.fightBg,
            seed: seed,
            attackHeadInfo: param.attackHeadInfo,
            defendHeadInfo: param.defendHeadInfo,
            fightType,
            skipText: param.skipText || "跳过",
            isFury: fightType == "pve" ? false : true,
            fightIndex: index == 1 ? null : index, // 战斗场次
            fightStartNeedChangeAttr: param.fightStartNeedChangeAttr, // 要改变的属性
            notCleanData: false,
            bossId: param.bossId,
            monsterSeaHurtCfg: param.monsterSeaHurtCfg,
            shengqiInfo: shengqiInfo?.get(index),
            endCallback: (r, stateId, resultData) => {//战斗结束回调
                fightResult.push({ result: r, resultData });
                roundInfo.push({
                    isWin: r,
                    round: resultData.count,
                    ownTeam: resultData.recount.attack,
                    emeryTeam: resultData.recount.defend
                })
                if (r != 1) {
                    param.endCallback && param.endCallback(2, {roundInfo, closeCallBack: resultData.closeCallBack}, fightResult);
                    // !param.isFastSkip && globalSend("openFightAccount", {
                    //     r,
                    //     attackHeadInfo: resultData.attackHeadInfo,
                    //     defendHeadInfo: resultData.defendHeadInfo,
                    //     roundInfo: roundInfo,
                    //     openNextFightFun: param.openNextFightFun
                    // });
                    return;
                }
                if (index !== param.ownAttr.size) {
                    clearFightData();
                    index++;
                    fun(index);
                } else {
                    let isVistory = fightResult.filter((a) => a.result == 1).length == fightResult.length;
                    param.endCallback && param.endCallback(isVistory, {roundInfo, closeCallBack: resultData.closeCallBack}, fightResult);
                    // !param.isFastSkip && globalSend("openFightAccount", {
                    //     r: isVistory,
                    //     attackHeadInfo: resultData.attackHeadInfo,
                    //     defendHeadInfo: resultData.defendHeadInfo,
                    //     roundInfo: roundInfo,
                    //     openNextFightFun: param.openNextFightFun
                    // });
                }
            },
            closeCallback: () => {
                //战斗关闭回调
                param.closeCallback && param.closeCallback();
            }
        }
        globalSend("gotoFight", fightData);
    }
    fun(1);
}